//------------------------------------------------------------------------------
//
//  npjson.h
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/14/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
//------------------------------------------------------------------------------
#ifndef NPJSON_H_
#define NPJSON_H_


#include <stdio.h>
#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitJSON (void* dataRef);
void npCloseJSON (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenJSON (const char* fileName, const char* mode, void* dataRef);

FILE* npNewJSON (const char* fileName, const char* mode, void* dataRef);

FILE* npDialogJSON (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npCloseJSON (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadJSON (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteJSON (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveJSON (FILE* file, void* dataRef);

void npImportJSON (FILE* file, int type, void* dataRef);
void npExportJSON (FILE* file, void* dataRef);

// file and directory management
void npGetAttribJSON (int size, void* dataRef);
void npSetAttribJSON (int size, void* dataRef);

void npTestJSON (void* fileName, int wordSize, int size, void* dataRef);


#endif